#include        <stdio.h>
#include        <string.h>
#include	<sys/time.h>
#ifndef LINUX
#include	<sys/select.h>
#endif
#include	<sys/types.h>
#include        "inet.h"
#include        "dvm.h"
#include        "dvm_msg.h"
#include        <sys/errno.h>
 
#define         STDINOUT                (-1)    /* for stdio */
#define         FileType        (0)
 
extern          int     errno;
extern          struct task *_dvminfo;
extern          int     _total_data;
extern          int     _myvdcetaskid;
extern          int     _myvdcetaskname;
extern          FILE    *jfp;
extern          int     _myuserid;
extern          int     _myapplid;
extern          int     _cvmsockfd;

extern          VDCE_MSG_HEADER     _cvm_header;

extern 		ACT_format *_actinfo;

decode_command(recv_msg, command, msg_data)
char *recv_msg, *command, *msg_data;
{
	char *buf;
	
	char *token;
	WhoAmI appli;
	struct task channel;
	ACT_format *actinfo;

	strncpy(command, recv_msg, 4);
	buf = (char *)strchr(recv_msg, '\n');
	++buf;
	msg_data = buf;



	if (!strncmp(command, Task_Activation, 4) ||
	    !strncmp(command, Task_Deactivation, 4) ||
	    !strncmp(command, Task_Killing, 4) ||
	    !strncmp(command, Task_Completion, 4) )
	{
		token = strtok(msg_data, "\n");
		appli.user_id = atoi(token);	
		token = strtok(0, "\n");
		appli.appl_id = atoi(token);	
		token = strtok(0, "\n");
		appli.task_id = atoi(token);	
	     
	}
	if (!strncmp(command, CIT_Conf, 4) ||
	    !strncmp(command, New_Connection, 4)) 
	{

            	token = strtok(msg_data, "\n");
                channel.user_id = atoi(token);
                token = strtok(0, "\n");
                channel.appl_id = atoi(token);
                token = strtok(0, "\n");
                strcpy(channel.v_name,  token);
                token = strtok(0, "\n");
                channel.v_type = atoi(token);
                token = strtok(0, "\n");
                strcpy(channel.s_name,  token);
                token = strtok(0, "\n");
                channel.s_pid = atoi(token);
                token = strtok(0, "\n");
                channel.s_port = atoi(token);
                token = strtok(0, "\n");
                channel.s_tkid = atoi(token);
                token = strtok(0, "\n");
                channel.s_socket = atoi(token);
                token = strtok(0, "\n");
                strcpy(channel.d_name,  token);
                token = strtok(0, "\n");
                channel.d_pid = atoi(token);
                token = strtok(0, "\n");
                channel.d_port = atoi(token);
                token = strtok(0, "\n");
                channel.d_tkid = atoi(token);
                token = strtok(0, "\n");
                channel.d_socket = atoi(token);
 

	}

        if (!strncmp(command, ACT_Feature, 4)) 
        {
 
		actinfo = _actinfo;
                token = strtok(msg_data, "\n");
                actinfo->user_id = atoi(token);
                token = strtok(0, "\n");
                actinfo->appl_id = atoi(token);
                token = strtok(0, "\n");
                actinfo->task_id = atoi(token);
                token = strtok(0, "\n");
                actinfo->comm_type = atoi(token);
                token = strtok(0, "\n");
                actinfo->thread_type = atoi(token);
                token = strtok(0, "\n");
                actinfo->comm_protocol = atoi(token);
                token = strtok(0, "\n");
                strcpy(actinfo->QoS,  token);


        }
 


	switch(atoi(command)) {

	  case 1 : /* CIT_Conf */
          {
#ifdef DEBUG
	     fprintf(jfp,"Received CIT_Conf command\n");
	     fflush(jfp);
#endif
				break;
	  }
	  case 3 : /*Task_Activation */ 
          {
#ifdef DEBUG
	     fprintf(jfp,"Received Task Activation Request\n");
	     fflush(jfp);
#endif
		 break;
	  }
	  case 4 : /*Task_Deactivation */
          {
#ifdef DEBUG
	     fprintf(jfp,"Received Task Deactivation\n");
	     fflush(jfp);
#endif
		break;
	  }
	  case 5 : /*Task_killng */
          {
#ifdef DEBUG
	     fprintf(jfp,"Received Task Stop Request\n");
	     fflush(jfp);
#endif
		vdce_stop(0);
		exit(0);
		break;
	  }
	  case 10 : /* ACT_Feature */
          {
#ifdef DEBUG
	     fprintf(jfp,"Received ACT_Feature Request\n");
	     fflush(jfp);
#endif
		break;
	  }
	  case 11 : /* New_Connection */
	  {
#ifdef DEBUG
	     fprintf(jfp,"Received New_Connection Request\n");
	     fflush(jfp);
#endif
		break;
	  }
	  default : /* No action defined for this message */
          {
#ifdef DEBUG
	     fprintf(jfp,"Received %d Message from LCVM \n",atoi(command));
	     fflush(jfp);
#endif
	  }
	} /* end of switch */
}


/*-----------------------------------------------------------------------------
 *
 *    Name     : READN_AVAIL
 *
 *    Function : Check the availability of any unread message amongst all
 *               connections.
 *    Input    : int *fdwk - file descriptor pointer.
 *    Output   : return 1 if found; otherwise return 0.
 *               the file descriptor pointer will point to the file descriptor
 *               of the unread message.
 *
 *---------------------------------------------------------------------------*/
int readn_avail(fdwk)
int *fdwk;
{
    int    i, fd, nread, nselect;
    int    found, maxfd = 0;
    struct timeval tv;
    fd_set read_fds;
    char   tempbuff[2];
 
    found      = 0; /* No message arrived         */
    tv.tv_sec  = 0; /* No delay, instantly return */
    tv.tv_usec = 0;
    FD_ZERO(&read_fds);
 
    /* set up read_fds and maxfd */
        fd = *fdwk;
        FD_SET(fd, &read_fds);
        if ( maxfd < fd ) maxfd = fd;
 
    /* select amongst all file descriptors */
    nselect = select(maxfd+1, &read_fds, 0, 0, &tv);
 
    if ( nselect > 0 ) { /* select okay */
      /* unread message exists. search the file descriptor */
           if ( FD_ISSET(fd, &read_fds) ) {
              while ((nread = recv(fd,tempbuff,1,MSG_PEEK))==-1);
              if ( nread == 0 ) { /* if eof          */
                 found = 0; /* clear done flag */
              }
              else {              /* not eof         */
                 *fdwk = fd;      /* fd with event   */
                 found = 1;       /* set found flag  */
              }
           }
        }
    else if ( nselect < 0 ) { /* select error */
      fprintf(jfp, "%d select error\n", _myvdcetaskid);
      exit(-1);
    }
    return(found); /* return found flag */
}

report_execution_time(time_type, total_time)
int time_type;
long total_time;
{
      int	sockfd = _cvmsockfd;
      char      msg[2048],msg_data[2048],*recv_msg,command[5];	
      VDCE_MSG_HEADER	msg_header;
      int       lcvm_sig = -1;
      int i,j;

         sprintf(msg, "%s\n%d\n%d\n%d\n%d\n%d\n%d\n", 
	Total_Execution_Time, 5,
	_myuserid, _myapplid, _myvdcetaskid, time_type, total_time);
                        /*userid, applid, taskid*/
      sprintf(_cvm_header.length, "%d",strlen(msg)+HEADERSIZE);
 
      for(i=0;i<5;i++) {
         send_data_using_msg(sockfd, _cvm_header,msg, strlen(msg));
	 sleep(5);
      }

       /*get confirmation from lcvm about report_time_exectuion */
 
#ifdef TIMEACK
       fprintf(jfp,"VDCE_Report:Waiting for ACK_MSG_EXEC_TIME \n");
       fflush(jfp);
        recv_data_using_msg(sockfd, &msg_header, &recv_msg);
        decode_command(recv_msg, command, msg_data);
        if (!strncmp(command, ACK_Exec_Time, 4))
                lcvm_sig =0;
 
        while (lcvm_sig != 0) {
                sleep(2);
                send_data_using_msg(sockfd, _cvm_header, msg,strlen(msg));
                /*get confirmation from lcvm about ACK_Exec_Time */
                recv_data_using_msg(sockfd, &msg_header, &recv_msg);
                decode_command(recv_msg, command, msg_data);
                if (!strncmp(command, ACK_Exec_Time, 4))
                        lcvm_sig =0;
        }
#endif

}

